function BS_Line::onLine(%this,%html)
{
	%this.parseHTML(%html);
}

function BS_Line::onDisconnected(%this)
{
	echo("bye");
}

//**************************************************************
//*********** Blockland Streaming Line - Networking ************
//**************************************************************

//       Parser, by current style
//--------------------------------------
function BS_Line::parseHTML(%this,%html)
{
	//Get the current parsing style
	%style = %this.htmlParseStyle;
	
	if(%style $= "Populate")
	{
		//echo(%html);
		%htmlLow = strLwr(%html);
		
		if(strStr(%htmlLow,"<a href") >= 0)
		{
			if(strStr(%htmlLow,"?topic=") >= 0)
			{
					//echo(%html);
				%topicName = getSubStr(%htmlLow,strStr(%htmlLow,">"),strLen(%htmlLow));
				%topicName = getSubStr(%topicName,1,strStr(%topicName,"<")-1);
				$BS::ThreadLink[%topicName] = getSubStr(%htmlLow,strStr(%htmlLow,"http:"),strLen(%htmlLow));
				$BS::ThreadLink[%topicName] = getSubStr($BS::ThreadLink[%topicName],0,strStr($BS::ThreadLink[%topicName],"\">"));
				$BS::ThreadName[$BS::ThreadLink[%topicName]] = %topicName;
				echo($BS::ThreadLink[%topicName]);
			
				if($BS::ParseCommand $= "Populate")
				{
					StreamCtrl_Boards_Threads.addRow(StreamCtrl_Boards_Threads.getCount(),formatStringFromWeb(%topicName),1);
					cancel($revertToOldStyle);
					$revertToOldStyle = schedule(1000,0,eval,"BS_Line.htmlParseStyle = $BS::oldStyle;");
				}
			}
		}
	}
	else
	if(%style $= "InfoThread")
	{
		echo(%html);
	}
	else
	if(%style $= "lastResponse")
	{
		%htmlLow = strLwr(%html);
		
		echo(%htmlLow);
		if(strStr(%htmlLow,"action=profile;") >= 0)
		{
			%user = getSubStr(%htmlLow,strStr(%htmlLow,"u="),strLen(%htmlLow));
			%user = getSubStr(%user,strStr(%user,">")+1,strLen(%user));
			%user = getSubStr(%user,0,strStr(%user,"<"));
			$BS::lastTopicUser = %user;
		}
		if(strStr(%htmlLow,"<div class=\"post\"") >= 0)
		{
			if(strStr(%htmlLow,"class=\"quote\"") >= 0)
			{
				//$string = getSubStr(%htmlLow,strStr(%htmlLow,"class=\"quote\""),strLen(%htmlLow));
				//$string = getSubStr($string,strStr($string,">"),strLen($string)-3);
				//echo("string = "@$string);
				//echo(%htmllow);
				%div = true;
				%line = %htmlLow;
				%a = -1;
				
				while(%div)
				{
					if(strStr(%line,"</div>") < 0)
					{
						$BS::lastTopicMessage = %oldLine[%a];
						$BS::lastTopicWasQuote = true;
						echo("\c4String was "@$BS::lastTopicMessage);
						break;
					}
					
					if(%line !$= "")
						%oldLine[%a++] = %line;
						
					%line = getSubStr(%line,strStr(%line,"</div>")+6,strLen(%line));
				}
			}
			else
			{
				$BS::lastTopicMessage = getSubStr(%htmlLow,strStr(%htmlLow,"post\">")+6,strLen(%htmlLow));
				$BS::lastTopicWasQuote = "";
			}
		}
		
		if(strStr(%htmlLow,"</html>") >= 0)
		{
			
			$BS::lastTopicMessage = strReplace($BS::lastTopicMessage,"</div>","");
			$BS::lastTopicMessage = stripMlControlChars($BS::lastTopicMessage);
			echo("\c4STRING: "@$BS::lastTopicMessage);
			$BS::LastTopicMessage = formatStringFromWeb($BS::lastTopicMessage);
			//$BS::lastTopicMessage = "";
			
			if($BS::oldStyle !$= "")
			{
				%this.htmlParseStyle = $BS::oldStyle;
				$BS::oldStyle = "";
			}
			
			if($BS::parseCommand !$= "")
			{
				if($BS::parseCommand $= "ExpandNotification")
				{
					%notification = BS_InterfaceContainer.activeNotification;
					
					if(isObject(%notification))
					{
						if($BS::lastTopicWasQuote !$= "")
							%add = " to a quote.";
						messageBoxOk("This message box is temporary!",$BS::lastTopicUser @" says\n\n"@$BS::lastTopicMessage@%add);
					}
				}
			}
			//echo("\c4"@%htmlLow);
		}
	}
	else
	if(%style $= "Board" || %style $= "BoardSpecific")
	{
		//Lower the html content
		%htmlLow = strLwr(%html);
		
		%bool = (strStr(%htmlLow,"<a href=\"http://forum.blockland.us/index.php?topic=") >= 0);

		if(%bool)
		{	
			//Parse and register variables for the current topic link
			//---------------------------------------------------------------------------------------------------------------------------------------------
			BS_Line.variable["Board","TopicLink"] = getSubStr(%htmlLow,strStr(%htmlLow,"href=\"") + 6,strLen(%htmlLow));
			BS_Line.variable["Board","TopicLink"] = getSubStr(BS_Line.variable["Board","TopicLink"],0,strStr(BS_Line.variable["Board","TopicLink"],"\">"));
			BS_Line.variable["Board","TopicLink"] = strReplace(BS_Line.variable["Board","TopicLink"],".0",".999999");
			//---------------------------------------------------------------------------------------------------------------------------------------------
			
			//Parse and register variables for the current topic name
			//-------------------------------------------------------------------------------------------------------------------------------------------
			BS_Line.variable["Board","TopicName"] = getSubStr(%htmlLow,strStr(%htmlLow,"\">"),strLen(%htmlLow));
			BS_Line.variable["Board","TopicName"] = getSubStr(BS_Line.variable["Board","TopicName"],2,strLen(BS_Line.variable["Board","TopicName"]) - 6);
			BS_Line.variable["Board","TopicName"] = getSubStr(BS_Line.variable["Board","TopicName"],0,strStr(BS_Line.variable["Board","TopicName"],"<"));
			//-------------------------------------------------------------------------------------------------------------------------------------------
		}
		
		%bool = (strStr(%htmlLow,"<a href=\"http://forum.blockland.us/index.php?action=profile;") >= 0 && getWordCount(%htmlLow) <= 3);
		
		if(%bool)
		{
			//Parse and register variables for the current topic creator
			//---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
			BS_Line.variable["Board","TopicCreator"] = getSubStr(%htmlLow,strStr(%htmlLow,";u="),strLen(%htmlLow));
			BS_Line.variable["Board","TopicCreator"] = getSubStr(BS_Line.variable["Board","TopicCreator"],strStr(BS_Line.variable["Board","TopicCreator"],"\">")+2,strLen(BS_Line.variable["Board","TopicCreator"])-6);
			BS_Line.variable["Board","TopicCreator"] = getSubStr(BS_Line.variable["Board","TopicCreator"],0,strStr(BS_Line.variable["Board","TopicCreator"],"<"));
			//---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		
		}
		
		%bool = ((strStr(%htmlLow,"<span class=\"smalltext\"><b>") >= 0) && (BS_Line.variable["Board","TopicName"] !$= ""));

		if(%bool)
		{
			//Parse and register variables for the current topic poster
			//------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
			BS_Line.variable["Board","TopicPoster"] = getSubStr(%htmlLow,strStr(%htmlLow,";u="),strLen(%htmlLow));
			BS_Line.variable["Board","TopicPoster"] = getSubStr(BS_Line.variable["Board","TopicPoster"],strStr(BS_Line.variable["Board","TopicPoster"],"\">")+2,strLen(BS_Line.variable["Board","TopicPoster"])-20);
			BS_Line.variable["Board","TopicPoster"] = getSubStr(BS_Line.variable["Board","TopicPoster"],0,strStr(BS_Line.variable["Board","TopicPoster"],"<"));
			//------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
			
			//Check container for current pending html match
			%child = BS_NetworkContainer.hasInContainer(BS_Line.variable["Board","TopicLink"]);
			
			if(%child !$= "false")
			{
				//Old child from the container, variables set
				//-------------------------------------------------
				%child["old","TopicLink"] = %child.topicLink;
				%child["old","TopicName"] = %child.topicName;
				%child["old","TopicCreator"] = %child.topicCreator;
				%child["old","TopicPoster"] = %child.topicPoster;
				//-------------------------------------------------
				
				//Create a new child
				%newChild = new scriptObject();
				
				//New child from creation, variables set
				//----------------------------------------------------------------------
				%child["new","TopicLink"] = BS_Line.variable["Board","TopicLink"];
				%child["new","TopicName"] = BS_Line.variable["Board","TopicName"];
				%child["new","TopicCreator"] = BS_Line.variable["Board","TopicCreator"];
				%child["new","TopicPoster"] = BS_Line.variable["Board","TopicPoster"];
				//----------------------------------------------------------------------
				
				if( (%child["old","TopicName"] $= %child["new","TopicName"] &&
				%child["old","TopicCreator"] $= %child["new","TopicCreator"] &&
				%child["old","TopicPoster"] !$= %child["new","TopicPoster"]) )
				{
					//Head and body content for the notification object
					//-----------------------------------------------------------
					%head = %child["new","topicPoster"] @ " replied to a topic:";
					%body = %child["new","topicName"];
					//-----------------------------------------------------------
					
					if(%style $= "BoardSpecific")
					{
						%tempChild = %child["new","TopicLink"];
						%tempChildSub = getSubStr(%tempChild,strStr(%tempChild,"topic="),strLen(%tempChild));
						%tempChildRem = getSubStr(%tempChildSub,strStr(%tempChildSub,"."),strLen(%tempChildSub));
						%tempChild = strReplace(%tempChild,%tempChildRem,"");
						%tempChild = strReplace(%tempChild,"https://","");
						%tempChild = strReplace(%tempChild,"http://","");
						%match = 0;
						
						for(%i=0;%i<getWordCount($pref::BlocklandStreaming::ThreadsList);%i++)
						{
							%tl = getWord($pref::BlocklandStreaming::ThreadsList,%i);
							%tlSub = getSubStr(%tl,strStr(%tl,"topic="),strLen(%tl));
							%tlRem = getSubStr(%tlSub,strStr(%tlSub,"."),strLen(%tlSub));
							%tl = strReplace(%tl,%tlRem,"");
							%tl = strReplace(%tl,"https://","");
							%tl = strReplace(%tl,"http://","");
							
							echo(%tl @" $= "@%tempChild);
							
							if(%tl $= %tempChild)
							{
								%match = true;
								break;
							}
						}

						if(%match)
						{
							//Write notification
							%notification = BS_interface.writeNotification(%head,%body,5000);
							
							//Set the notification's topic link
							%notification.topicLink = BS_Line.variable["Board","TopicLink"];
						}
					}
					else
					{
						//Write notification
						%notification = BS_interface.writeNotification(%head,%body,5000);
						
						//Set the notification's topic link
						%notification.topicLink = BS_Line.variable["Board","TopicLink"];
					}
					
					echo("new reply in topic "@bs_line.variable["Board","TopicName"]);
					
					//Cleanup
					//----------------------------------------
					BS_NetworkContainer.remove(%child);
					BS_NetworkContainer.add(%newChild);
					BS_NetworkContainer.pushToBack(%newChild);
					BS_NetworkContainer.cleanUp();					
					%child.delete();
					//----------------------------------------
				}
			}
			else
			{
				//Create the first child
				%firstChild = new scriptObject();
				
				//First child's variables
				//----------------------------------------------------------------
				%firstChild.topicLink = BS_Line.variable["Board","TopicLink"];
				%firstChild.topicName = BS_Line.variable["Board","TopicName"];
				%firstChild.topicCreator = BS_Line.variable["Board","TopicCreator"];
				%firstChild.topicPoster = BS_Line.variable["Board","TopicPoster"];
				//----------------------------------------------------------------
				
				//Place the first child into the container
				//------------------------------------------
				BS_NetworkContainer.add(%firstChild);
				BS_NetworkContainer.pushToBack(%firstChild);
				BS_NetworkContainer.cleanUp();
				//------------------------------------------
			}
		}
	}
}

//Get data, ready for parsing loop
//----------------------------------
function BS_Line::watch(%this,%link)
{
	//Cancel any pending loops
	if(isEventPending(%this.watchLoop))
		cancel(%this.watchLoop);

	%type = %this.HtmlParseStyle;

	if(%type $= "Board" || %type $= "BoardSpecific")
	{
		//HTTP Get
		%this.get("forum.blockland.us:80",%link);
	}

	%this.watchLoop = %this.schedule(5000,watch,%link);
}

function BS_Line::onDnsFailed(%this)
{
	BS_Interface.writeNotification("Network Error","It seems you are not connected to the internet. :(",15000);
	cancel(%this.watchloop);
}

function BS_Line::addToThreadsList(%this,%link)
{
	%list = $Pref::BlocklandStreaming::ThreadsList[$BS::CurrentBoard];

	if(strStr(strLwr(%list),strLwr(%link)) >= 0)
	{
		warn("Cannot add the same link to the watchlist twice!");
		return false;
	}
	else
	if($BS::CurrentBoard $= "")
	{
		messageBoxOk("You first need to start watching a board!");
		return false;
	}
	
	$Pref::BlocklandStreaming::ThreadsList[$BS::CurrentBoard] = %link SPC $Pref::BlocklandStreaming::ThreadsList[$BS::CurrentBoard];
	
	return $Pref::BlocklandStreaming::ThreadsList[$BS::CurrentBoard];
}

function BS_Line::removeFromThreadsList(%this,%link)
{
	%list = $Pref::BlocklandStreaming::ThreadsList[$BS::CurrentBoard];

	if(strStr(strLwr(%list),strLwr(%link)) <= -1)
	{
		warn("No such link to be removed!");
		return false;
	}
	else
	if($BS::CurrentBoard $= "")
	{
		messageBoxOk("You first need to start watching a board!");
		return false;
	}
	
	$Pref::BlocklandStreaming::ThreadsList[$BS::CurrentBoard] = strReplace($Pref::BlocklandStreaming::ThreadsList[$BS::CurrentBoard],%link,"");
	$Pref::BlocklandStreaming::ThreadsList[$BS::CurrentBoard] = strReplace($Pref::BlocklandStreaming::ThreadsList[$BS::CurrentBoard],"  "," ");
	$Pref::BlocklandStreaming::ThreadsList[$BS::CurrentBoard] = trim($Pref::BlocklandStreaming::ThreadsList[$BS::CurrentBoard]);
	
	StreamCtrl_Threads.clear();
	BS_Control.populateThreadWatchList();
	
	return $Pref::BlocklandStreaming::ThreadsList[$BS::CurrentBoard];
}

function BS_Line::echoWatchList(%this)
{
	echo($pref::blocklandStreaming::ThreadsList[$BS::CurrentBoard]);
}

//Checks BS_NetworkContainer for a child named %link
//-------------------------------------------------------
function BS_NetworkContainer::hasInContainer(%this,%link)
{
	//Initialize
	//----------------------------
	%count = %this.getCount();
	//----------------------------
	
	for(%i=0;%i<%count;%i++)
	{
		//Get child from container
		%child = %this.getObject(%i);

		if(%child.topicLink $= %link)
		{
			return %child;
		}
	}
	
	return "false";
}

function BS_NetworkContainer::listObjectNames(%this)
{
	%count = %this.getCount();
	
	for(%i=0;%i<%count;%i++)
	{
		%o = %this.getObject(%i);
		
		echo(%o.topicName);
	}
}

function BS_NetworkContainer::cleanUp(%this)
{
	%count = %this.getCount();
	
	for(%i=0;%i<%count;%i++)
	{
		%o = %this.getObject(%i);
		
		if(%o.topicName $= "")
			%o.delete();
	}
}

function formatStringFromWeb(%string)
{
	%string = strReplace(%string,"&gt;",">");
	%string = strReplace(%string,"&#039;","'");
	%string = strReplace(%string,"<br />","\n");
	%string = stripMlControlChars(%string);
}