function BS_NetworkConnect::onDNSFailed(%this)
{
	BS_Interface.writeNotification("Oops!","It seems you have no connection to the internet!",5000);
	echo("DNS Failed");
}
 
function BS_NetworkConnect::onConnected(%this)
{
	%name = %this.clientName;

	%this.sendline("NICK "@%name@"\r\n");
	%this.sendline("USER "@%name@" 0 * :client\r\n");
}

function BS_NetworkConnect::onConnectFailed(%this)
{
}

function BS_NetworkConnect::onDisconnect(%this)
{
}

function BS_NetworkConnect::onLine(%this, %line)
{
	if(getword(%line, 0) $= "PING")
	{
		%this.sendline("PONG" SPC getword(%line, 1) @ "\r\n");
	}
	else if(strpos(%line, "376") > -1)
	{
		%this.sendline("JOIN #elmsserver\r\n");
	}
	
	if(strStr(%line,"PRIVMSG #elmsserver") >= 0)
	{
		%user = getSubStr(%line,1,strStr(%line,"!webchat@")-1);
		%text = getSubStr(%line,1,strLen(%line));
		%text = getSubStr(%text,strStr(%text,":")+1,strLen(%text));
		echo(%user @" | "@%text);
	}
	else
	if(strStr(%line,"JOIN") >= 0)
	{
		%user = getSubStr(%line,1,strStr(%line,"!")-1);
		echo("player joined");
		//if bs control is awake, add player, otherwise we can just get all players when we open the gui
	}
	else
	if(strStr(%line,"QUIT") >= 0)
	{
		%user = getSubStr(%line,1,strStr(%line,"!")-1);
		//same shit here, but maybe we should only request all players once, and keep track of them.. goodnight
	}
	
	if(strStr(%line,"353") >= 0)
	{
		$BS::UserNamesList = getSubStr(%line,1,strLen(%line));
		$BS::UserNamesList = getSubStr($BS::UserNamesList,strStr($BS::UserNamesList,":")+1,strLen($BS::UserNamesList));
		BS_Control.populateUsersList();
	}
	echo("LINE + "@%line);
}

function BS_NetworkConnect::sendline(%this, %line)
{
	%this.send(%line);
}